/**
 *
 * Created by Kyle Benk kylebenkapps.com
 *
 * 12/13
 */

jQuery(document).ready(function($) {

	$("#nnr_plugin_content").fadeIn();

	$('[data-toggle="tooltip"]').tooltip();

	$('[rel="popover"]').popover({
        container: 'body',
        html: true,
        content: function () {
            var clone = $($(this).data('popover-content')).clone(true).removeClass('hide');
            return clone;
        }
    }).click(function(e) {
        e.preventDefault();
    });

    // Add Optin

	$("." + nnr_of_data.prefix_dash + "add-optin").click(function(e){
		e.preventDefault();
		$("." + nnr_of_data.prefix_dash + "create-optin").each(function(){
			$(this).attr('data-add', 'optin');
		});
	});

	// Add new

	$("." + nnr_of_data.prefix_dash + "create-optin").click(function(e){

		// Add Border

		e.preventDefault();

		$("." + nnr_of_data.prefix_dash + "create-optin").removeClass(nnr_of_data.prefix_dash + "create-optin-selected");
		$(this).addClass(nnr_of_data.prefix_dash + "create-optin-selected");

	});

	// Create optin

	$("#" + nnr_of_data.prefix_dash + "optin-fire-type ." + nnr_of_data.prefix_dash + "create-optin-button").click(function(e){

		if ( $("#" + nnr_of_data.prefix_dash + "optin-fire-type ." + nnr_of_data.prefix_dash + "create-optin-selected").length == 0 ) {
			return;
		}

		$.post(ajaxurl, {
			'action': 'nnr_of_add_new',
			'type' : $("#" + nnr_of_data.prefix_dash + "optin-fire-type ." + nnr_of_data.prefix_dash + "create-optin-selected").attr('data-type')}, function(response) {

			window.location = response;

		});
	});

	// Create variant

	$("#" + nnr_of_data.prefix_dash + "optin-fire-add-variant ." + nnr_of_data.prefix_dash + "create-variant-button").click(function(e){

		if ( $("#" + nnr_of_data.prefix_dash + "optin-fire-add-variant ." + nnr_of_data.prefix_dash + "create-optin-selected").length == 0 ) {
			return;
		}

		$.post(ajaxurl, {
			'action': 'nnr_of_add_variant',
			'type' : $("#" + nnr_of_data.prefix_dash + "optin-fire-add-variant ." + nnr_of_data.prefix_dash + "create-optin-selected").attr('data-type'),
			'optin_fire_id' : $("." + nnr_of_data.prefix_dash + "create-optin-selected").data('optin-fire-id'),
			'name': $("#" + nnr_of_data.prefix_dash + "test-name").val()}, function(response) {

			window.location = response;

		});
	});

	// Change Status

	$("." + nnr_of_data.prefix_dash + "change-status").click(function(e){

		e.preventDefault();
		//$(this).append('<i class="fa fa-spinner fa-spin"></i>');

		var id = $(this).attr('data-optin-fire-id');

		$.post(ajaxurl, {
			'action': 'nnr_of_change_status',
			'optin_fire_id' : $(this).attr('data-optin-fire-id'),
			'status' : $(this).data('status')}, function(response) {


			$("tr[data-optin-fire-id='" + id + "'] .status.column-status label").remove();
			$("tr[data-optin-fire-id='" + id + "'] ." + nnr_of_data.prefix_dash + "change-status i").remove();

			if ($("tr[data-optin-fire-id='" + id + "'] ." + nnr_of_data.prefix_dash + "change-status").data('status') == 'Inactive') {
				$("tr[data-optin-fire-id='" + id + "'] ." + nnr_of_data.prefix_dash + "change-status").data('status', 'Active');
				$("tr[data-optin-fire-id='" + id + "'] ." + nnr_of_data.prefix_dash + "change-status").parent().removeClass('delete').addClass('edit');
				$("tr[data-optin-fire-id='" + id + "'] .status.column-status")
					.prepend('<label style="color:red;"><span class="glyphicon glyphicon-minus"></span> OFF</label>');
			} else {
				$("tr[data-optin-fire-id='" + id + "'] ." + nnr_of_data.prefix_dash + "change-status").data('status', 'Inactive');
				$("tr[data-optin-fire-id='" + id + "'] ." + nnr_of_data.prefix_dash + "change-status").parent().removeClass('edit').addClass('delete');
				$("tr[data-optin-fire-id='" + id + "'] .status.column-status")
					.prepend('<label style="color:green;"><span class="glyphicon glyphicon-ok"></span> ON</label>');
			}

			// Reload the page

			window.location = window.location;

		});

	});

	// Change Testing Status

	$("." + nnr_of_data.prefix_dash + "change-test-status").click(function(e){

		e.preventDefault();
		$(this).append('<i class="fa fa-spinner fa-spin"></i>');

		$.post(ajaxurl, {
			'action': 'nnr_of_change_test_status',
			'optin_fire_id' : $(this).attr('data-optin-fire-id'),
			'status' : $(this).data('test-status')}, function(response) {

			$("tr[data-optin-test-id='" + response + "'] .status.column-status label").remove();
			$("tr[data-optin-test-id='" + response + "'] ." + nnr_of_data.prefix_dash + "change-status i").remove();

			if ($("tr[data-optin-test-id='" + response + "'] ." + nnr_of_data.prefix_dash + "change-test-status").data('test-status') == 'resume') {
				$("tr[data-optin-test-id='" + response + "'] ." + nnr_of_data.prefix_dash + "change-test-status").data('test-status', 'pause');
				$("tr[data-optin-test-id='" + response + "'] ." + nnr_of_data.prefix_dash + "change-test-status").html('Pause <i class="fa fa-pause"></i>');
				//$("tr[data-optin-test-id='" + response + "'] .name.column-name > i").addClass('fa-spin');
			} else {
				$("tr[data-optin-test-id='" + response + "'] ." + nnr_of_data.prefix_dash + "change-test-status").data('test-status', 'resume');
				$("tr[data-optin-test-id='" + response + "'] ." + nnr_of_data.prefix_dash + "change-test-status").html('Start <i class="fa fa-play"></i>');
				//$("tr[data-optin-test-id='" + response + "'] .name.column-name > i").removeClass('fa-spin');
			}

			$("." + nnr_of_data.prefix_dash + "change-test-status .fa-spin").remove();

		});

	});

	// Duplicate Optin Fire

	$("." + nnr_of_data.prefix_dash + "duplicate").click(function(e){

		e.preventDefault();
		$(this).append('<i class="fa fa-spinner fa-spin"></i>');

		var id = $(this).data('optin-fire-id');

		$.post(ajaxurl, {
			'action': 'nnr_of_duplicate',
			'optin_fire_id' : id}, function(response) {


			$("tr[data-optin-fire-id='" + id + "'] .status.column-status label").remove();

			// Reload the page

			window.location = window.location;

		});

	});

	// Start A/B Test

	$("." + nnr_of_data.prefix_dash + "ab-test").click(function(e){

		e.preventDefault();
		$(this).append('<i class="fa fa-spinner fa-spin"></i>');

		var id = $(this).data('optin-fire-id');

		$.post(ajaxurl, {
			'action': 'nnr_of_ab_test',
			'status' : $(this).data('action'),
			'optin_fire_id': $(this).data('optin-fire-id')}, function(response) {

			response = jQuery.parseJSON(response);

			$("tr[data-optin-fire-id='" + id + "'] ." + nnr_of_data.prefix_dash + "ab-test i").remove();

			if ($("tr[data-optin-fire-id='" + id + "'] ." + nnr_of_data.prefix_dash + "ab-test").data('action') == 'start') {

				$("tr[data-optin-fire-id='" + id + "'] ." + nnr_of_data.prefix_dash + "ab-test").data('action', 'stop');
				$("tr[data-optin-fire-id='" + id + "'] ." + nnr_of_data.prefix_dash + "ab-test").removeClass('btn-success').addClass('btn-danger');
				$("tr[data-optin-fire-id='" + id + "'] .ab.column-ab label").html('<span style="position: relative;top: -3px;" class="fa-stack"><i class="fa fa-circle fa-stack-2x"></i><i class="fa fa-stack-1x" style="color: white;font-weight: bold;position: relative;top: -1px;">A</i></span>');

				// Reload the page

				window.location = window.location;

			} else if ($("tr[data-optin-fire-id='" + id + "'] ." + nnr_of_data.prefix_dash + "ab-test").data('action') == 'stop') {

				$("tr[data-optin-fire-id='" + id + "'] ." + nnr_of_data.prefix_dash + "ab-test").data('action', 'start');

				$("tr[data-optin-fire-id='" + id + "'] .ab.column-ab label").html('<label>-</label>');
				$("tr[data-optin-fire-id='" + id + "'] ." + nnr_of_data.prefix_dash + "ab-test").removeClass('btn-danger').addClass('btn-success');

				$("tr[data-optin-fire-id='" + response.id + "'] ." + nnr_of_data.prefix_dash + "ab-test").data('action', 'start');

				$("tr[data-optin-fire-id='" + response.id + "'] .ab.column-ab label").html('<label>-</label>');
				$("tr[data-optin-fire-id='" + response.id + "'] ." + nnr_of_data.prefix_dash + "ab-test").removeClass('btn-danger').addClass('btn-success');
			}

		});

	});

	// Add Variant

	$("." + nnr_of_data.prefix_dash + "add-variant").click(function(e){

		$("." + nnr_of_data.prefix_dash + "test-name-header").remove();
		$("." + nnr_of_data.prefix_dash + "test-name-row").remove();
		$("." + nnr_of_data.prefix_dash + "test-name-group").remove();

		e.preventDefault();

		var add_variant = $(this);

		$("." + nnr_of_data.prefix_dash + "create-optin").each(function(){
			$(this).attr('data-add', 'variant');
			$(this).attr('data-optin-fire-id', add_variant.data('optin-fire-id'));
		});

		if ( add_variant.closest('tr').data('type') == '1' ||
		     add_variant.closest('tr').data('type') == '2' ||
		     add_variant.closest('tr').data('type') == '3' ) {
			$('#' + nnr_of_data.prefix_dash + 'optin-fire-add-variant .' + nnr_of_data.prefix_dash + 'create-optin-container[data-type="4"]').hide();
			$('#' + nnr_of_data.prefix_dash + 'optin-fire-add-variant .' + nnr_of_data.prefix_dash + 'create-optin-container[data-type="5"]').hide();
		} else {
			$('#' + nnr_of_data.prefix_dash + 'optin-fire-add-variant .' + nnr_of_data.prefix_dash + 'create-optin-container[data-type="4"]').show();
			$('#' + nnr_of_data.prefix_dash + 'optin-fire-add-variant .' + nnr_of_data.prefix_dash + 'create-optin-container[data-type="5"]').show();
		}

		if ( $("#" + nnr_of_data.prefix_dash + "test-name").length == 0 ) {

			if ( !$(this).hasClass(nnr_of_data.prefix_dash + 'parent') ) {

				$('.' + nnr_of_data.prefix_dash + 'add-optin-body').prepend('<h4 class="' + nnr_of_data.prefix_dash + 'test-name-header">1. Set Test Name</h4>' +
				'<hr class="' + nnr_of_data.prefix_dash + 'test-name-row"/>' +
				'<div style="width: 100%;display: inline-block;" class="form-group ' + nnr_of_data.prefix_dash + 'test-name-group">' +
					'<div class="col-sm-12">' +
						'<input class="form-control" id="' + nnr_of_data.prefix_dash + 'test-name" name="' + nnr_of_data.prefix_dash + 'test-name" value="' + add_variant.data('name') + ' Test">' +
					'<em class="help-block">When you create your first variant, you are actually creating a "Test" between two optins. Name this test something that explains what you\'re testing.</em>' +
				'</div>');

				$('.' + nnr_of_data.prefix_dash + 'optin-type-heading').html('2. Select Optin Type');

			} else {

				$('.' + nnr_of_data.prefix_dash + 'add-optin-body').prepend(
				'<div style="width: 100%;display: inline-block;" class="' + nnr_of_data.prefix_dash + 'test-name-group hidden">' +
					'<div class="col-sm-12">' +
						'<input class="form-control" id="' + nnr_of_data.prefix_dash + 'test-name" name="' + nnr_of_data.prefix_dash + 'test-name" value="' + add_variant.data('name') + '">' +
						'<em class="help-block"></em>' +
					'</div>' +
				'</div>');

				$('.' + nnr_of_data.prefix_dash + 'optin-type-heading').html('1. Optin Type');
				$('.' + nnr_of_data.prefix_dash + 'optin-type-heading').css('padding-top', 0);
			}

		}

		if ( $(this).hasClass(nnr_of_data.prefix_dash + 'parent') ) {

			$("." + nnr_of_data.prefix_dash + "test-name-header").remove();
			$("." + nnr_of_data.prefix_dash + "test-name-row").remove();
			$("." + nnr_of_data.prefix_dash + "test-name-group").remove();
		}

	});

	// End Test

	$(document).on('click', 'input[name="nnr-of-optin-fire-chosen"] + label', function(e){
		$(this).prev().prop('checked', true);
	});

	$("." + nnr_of_data.prefix_dash + "end-test").click(function(){

		$('#' + nnr_of_data.prefix_dash + 'optin-fire-end-test .modal-body').prepend('<div style="text-align: center;"><i class="fa fa-5x fa-spinner fa-spin"></i></div>');

		var row = $(this).closest('tr');

		$('#' + nnr_of_data.prefix_dash + 'optin-fire-end-test').modal('show');
		$('#' + nnr_of_data.prefix_dash + 'optin-fire-end-test').attr('data-parent-id', row.data('optin-test-id'));
		$('#' + nnr_of_data.prefix_dash + 'optin-fire-end-test .' + nnr_of_data.prefix_dash + 'end-test-data').remove();

		if ($('#' + nnr_of_data.prefix_dash + 'optin-fire-end-test .table').length == 0) {
			$.post(ajaxurl, {
				'action': 'nnr_of_get_end_test_options',
				'parent_id' : row.data('optin-test-id')}, function(response) {

				$('#' + nnr_of_data.prefix_dash + 'optin-fire-end-test .modal-body').find('.fa-spinner').remove();

				$("#" + nnr_of_data.prefix_dash + "loading-stats").remove();
				$('#' + nnr_of_data.prefix_dash + 'optin-fire-end-test .modal-body').prepend(response);

			});
		}

		$("#" + nnr_of_data.prefix_dash + "end-test-button").click(function(){
			$('#' + nnr_of_data.prefix_dash + 'optin-fire-end-test').modal('hide');
			$.post(ajaxurl, {
				'action': 'nnr_of_end_test',
				'parent_id' : $('#' + nnr_of_data.prefix_dash + 'optin-fire-end-test').data('parent-id'),
				'chosen_id' : $('input:radio[name="' + nnr_of_data.prefix_dash + 'optin-fire-chosen"]:checked').val()}, function(response) {

					// Reload the page

					window.location = window.location;

			});
		});
	});

	// Delete Optin

	$("." + nnr_of_data.prefix_dash + "delete").click(function(){

		var row = $(this).closest('tr');

		$("#" + nnr_of_data.prefix_dash + "optin-fire-delete .modal-body").find('p').html('Are you sure you want to delete <strong>' + row.data('name') + '</strong> and all of its stats.');

		$("#modal-success").click(function(){
			$('#' + nnr_of_data.prefix_dash + 'optin-fire-delete').modal('hide');

			$.post(ajaxurl, {
				'action': 'nnr_of_remove',
				'optin_fire_id' : row.data('optin-fire-id')}, function(response) {

					response = jQuery.parseJSON(response);

					if (response.id != '0') {
						$("tr[data-optin-fire-id='" + response.id + "'] .ab.column-ab label").html('<label>-</label>');
						$("tr[data-optin-fire-id='" + response.id + "'] ." + nnr_of_data.prefix_dash + "ab-test").removeClass('btn-danger').addClass('btn-success');
					}

					$("tr[data-optin-fire-id='" + response.id + "']").hide(1000, function() {
						$(this).remove();
					});
			});
		});
	});
});

